/***************************************************************
* Program: sockets.p
* Author : Steven Lichtenberg 
* Date   : 01/25/2001
* Purpose: General sockets APIs to be run persistently to create and delete 
*          sockets
* Tables Used:  none.  
* Modified:
****************************************************************/         

PROCEDURE GetSocketHandle :
 DEF OUTPUT PARAMETER op_hMySuperProcedure AS HANDLE NO-UNDO.
 ASSIGN op_hMySuperProcedure = THIS-PROCEDURE:HANDLE.
END PROCEDURE.


SUBSCRIBE TO "GetSocketHandle":U ANYWHERE.


function opensock returns handle (input purl as char,
    input pport as char):
    
    define variable hopener as handle no-undo.
    define variable ret     as log    no-undo.
    def var         connstr as char   no-undo.
      
    
    create socket hopener.
    connstr = "-H " + purl + " -S " + pport.
    ret = hopener:connect(connstr).
    if ret then return hopener.
    else return ?.
    delete object hopener no-error.
end function.  /* opensock */
 
function closesock returns logical(
    input hclose as handle):
    return hclose:disconnect().
	delete object hclose no-error.
end. /* function closesock */    
    
